#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/wait.h>
#include <sys/types.h>


int run_dynagen(char *path,char *conf,char qa){
	if(qa==1)
		return execl(path,path,"-q",conf,NULL);
	else
		return execl(path,path,conf,NULL);
}

int main(int argc, char* argv[]){
	int pid;
	int status;
	int pipefd[2],pipefd2[2],pipefd3[2];
	if(argc<3){
		printf("Usage:\n%s [foreground] <dynagen_path> <dynagen_conf>\n",argv[0]);
		exit(1);
	}
	
	if((pipe(pipefd) == -1)&&(pipe(pipefd2)==-1)&&(pipe(pipefd3) == -1)){
		perror("pipe");
		exit(EXIT_FAILURE);
	}
	
	pid=fork();
	switch(pid){
		case -1:
			perror("fork");
			exit(EXIT_FAILURE);
		case 0:
			if(strcmp(argv[1],"foreground")==0){
				if((close(pipefd[1])==-1) &&
					(close(pipefd2[0])==-1) &&
					(close(pipefd3[0])==-1) &&
					(dup2(pipefd[0],0)==-1) &&
					(dup2(pipefd2[1],1)==-1) &&
					(dup2(pipefd3[1],2)==-1)){
						perror("something is wrong");
						exit(EXIT_FAILURE);
				}
				return run_dynagen(argv[2],argv[3],1);
			}else{
				close(1);
				close(2);
				return run_dynagen(argv[1],argv[2],0);
			}
		default:
			if(strcmp(argv[1],"foreground")==0){
				close(pipefd[0]);
				write(pipefd[1],"\n",1);
				close(pipefd[1]);
		                wait(&status);
				return WEXITSTATUS(status);
			}else
				exit(EXIT_SUCCESS);
	}
}
