#!/bin/sh
. /opt/scripts/headers.sh

TMP_DIR="/tmp/simu/$USER/" #directory in which we can create temp files
if [ ! -d $TMP_DIR ];then mkdir $TMP_DIR; fi;
SIM_DIR=`mktemp -d -p $TMP_DIR` #we create directory to hold nescesary tmp data
CONF_ID="$2" #configuration of network
PORT_START="$1"
GROUP="simu"
DEVICE_LIST="$TMP_DIR/$DEVICE_LIST_FILE";
DEVICE_NAME="";
DEVICE_NAME_OLD="";
DYNAGEN_OUTPUTFILE="$TMP_DIR/$DYNAGEN_OUTPUT";
RSWITCH_CFG="/opt/cisco/conf/switch.cfg"
let PEMUS=1  #variable, whether we use pemu
DYNAGENCONF_PATH=`mktemp -p $TMP_DIR`".net"

XML_OUTPUT=`mktemp -p $TMP_DIR`".xml"

expr "$CONF_ID + 1" 2> /dev/null
if [ `echo $CONF_ID | sed 's/^[-+0-9][0-9]*//' | wc -c` -eq 1 ]; then
	CONF_STR=0;
	CONF="`/usr/bin/mysql -u $MYSQL_USER --password=$MYSQL_PASS $MYSQL_DB -r -L -N -e \"SELECT lab.configuration FROM lab,simulation WHERE simulation.id=$CONF_ID AND simulation.id_lab=lab.id;\" |grep -v '+-----'`";
else
	CONF_STR=1;
	CONF="`cat $CONF_ID`";
fi;

echo "<?xml version=\"1.0\"?>" > $XML_OUTPUT
echo "<device_list>" >> $XML_OUTPUT
#echo "<working_dir>$SIM_DIR</working_dir>" >> $XML_OUTPUT
echo "<working_dir>$TMP_DIR</working_dir>" >> $XML_OUTPUT
echo "<run_user>$USER</run_user>" >> $XML_OUTPUT

echo "creating tmp dir $SIM_DIR"
PEMUS=1
CON_PORT=$PORT_START;
let CON_PORT=$CON_PORT+1;
FW_PORT=`find_free_port $CON_PORT`;
let CON_PORT=$FW_PORT+1;

cd $SIM_DIR


PEMUS=$(
echo "$CONF" | while read line; do
	
	if [ -n "`echo $line|egrep \"^#\"`" ]; then
		continue;
	fi
	if [ -n "`echo $line|egrep \"console =\"`" ];then
		continue;
	fi
	
	#change paths to coresponds with unix sockets and start uml hosts and vde switches
	if [ -n "`echo $line|egrep \"(f|fa)([0-9]/)+([0-9])+ = host\"`" ];then
		HOST_NAME=`echo $line | awk '{ print $3 }' | tr -d ']' | tr -c -d '[:print:]'`
		DEVICE_NAME=${HOST_NAME}
		let CON_PORT=$CON_PORT+1;
		CON_PORT=`find_free_port $CON_PORT`;
		HOST_TMPDIR=`mktemp -d -p $SIM_DIR`
		#echo "Executing $VDE_PATH -daemon -sock $HOST_TMPDIR/switch"
		$VDE_PATH -daemon -sock $HOST_TMPDIR/switch
		#echo "Executing $UML_PATH ubda=$HOST_TMPDIR/cow,$UML_FS_PATH con1=port:$CON_PORT init=/etc/preinit eth0=daemon,,,$HOST_TMPDIR/switch/ctl" 1>&2
		sleep 1;
		$UML_PATH "ubda=$HOST_TMPDIR/cow,$UML_FS_PATH con1=port:$CON_PORT init=/etc/preinit eth0=daemon,,,$HOST_TMPDIR/switch/ctl" </dev/null >/dev/null & 
		
		line=`echo $line | sed -e "s@host@NIO_vde:$HOST_TMPDIR/switch/ctl:$HOST_TMPDIR/switch/dyna@g" `
		#generate xml output
		echo "<device>" >> $XML_OUTPUT
		echo "<type>host</type>" >> $XML_OUTPUT
		echo "<name>${DEVICE_NAME}</name>" >> $XML_OUTPUT
		echo "<port>$CON_PORT</port>" >> $XML_OUTPUT
		echo "</device>" >> $XML_OUTPUT
	fi

	
	if  [ -n "`echo $line|egrep -i \"\[\pemu"`" ];then
	
                let PEMUS=$PEMUS+1;

	fi

        if [ -n "`echo $line|egrep -i \"\[\[fw\"`" ];then
		FW_NAME=`echo $line | awk '{ print $2 }' | tr -d ']' | tr -c -d '[:print:]'`
		DEVICE_NAME=${FW_NAME}
		let PEMUS=$PEMUS+1;
		
		
		if [ $PEMUS -eq 3 ];then
		    echo $PEMUS;
		fi;
		
		                 

                let CON_PORT=$CON_PORT+1; 
		CON_PORT=`find_free_port $CON_PORT`;
           
	   	line="$line\nconsole = $CON_PORT"
		
		echo "<device>" >> $XML_OUTPUT
		echo "<type>fw</type>" >> $XML_OUTPUT
		echo "<name>${DEVICE_NAME}</name>" >> $XML_OUTPUT
		echo "<port>$CON_PORT</port>" >> $XML_OUTPUT
		echo "</device>" >> $XML_OUTPUT
        fi

	if [ -n "`echo $line|egrep -i \"\[\[router\"`" ];then
		ROUTER_NAME=`echo $line | awk '{ print $2 }' | tr -d ']' | tr -c -d '[:print:]'`
		DEVICE_NAME=${ROUTER_NAME}
		let CON_PORT=$CON_PORT+1;
		CON_PORT=`find_free_port $CON_PORT`;
		line="$line\nconsole = $CON_PORT"
		
		echo "<device>" >> $XML_OUTPUT
		echo "<type>router</type>" >> $XML_OUTPUT
		echo "<name>${DEVICE_NAME}</name>" >> $XML_OUTPUT
		echo "<port>$CON_PORT</port>" >> $XML_OUTPUT
		echo "</device>" >> $XML_OUTPUT
	fi

	if [ -n "`echo $line|egrep -i \"\[\[rswitch\"`" ];then
		RSWITCH_NAME=`echo $line | awk '{ print $2 }' | tr -d ']' | tr -c -d '[:print:]'`
		DEVICE_NAME=${RSWITCH_NAME}
		let CON_PORT=$CON_PORT+1;
		CON_PORT=`find_free_port $CON_PORT`;
		line="[[ROUTER $RSWITCH_NAME]]\nmodel = 3640\nslot0 = NM-16ESW\nconsole = $CON_PORT\ncnfg = $RSWITCH_CFG\n"
		echo "<device>" >> $XML_OUTPUT
		echo "<type>rswitch</type>" >> $XML_OUTPUT
		echo "<name>${DEVICE_NAME}</name>" >> $XML_OUTPUT
		echo "<port>$CON_PORT</port>" >> $XML_OUTPUT
		echo "</device>" >> $XML_OUTPUT
	fi

	if [ -n "`echo $line|egrep \"port =\"`" ];then
		if [ ! -n "`echo $line|egrep \"fwport\"`" ];then
		#line="port = $PORT_START"
		continue
		else
		continue
		#line="fwport = $FW_PORT"
		fi
	fi
	if [ -n "`echo $line|egrep \"workingdir =\"`" ];then
		line="workingdir = $SIM_DIR"
	fi

	# ingnore user defined udp port
	if [ -n "`echo $line|egrep \"udp =\"`" ];then
		continue;
	fi

	echo
	echo -e $line >> $DYNAGENCONF_PATH
	

	# change default upd port number
	if [ -n "`echo $line|egrep -i \"\[localhost\"`" ];then
		echo "udp = ${PORT_START}" >> ${DYNAGENCONF_PATH}
		echo "port = ${PORT_START}" >> ${DYNAGENCONF_PATH}
		echo "fwport = ${FW_PORT}" >> ${DYNAGENCONF_PATH}
	fi
	if [ "${DEVICE_NAME}" != "${DEVICE_NAME_OLD}" ]; then
		echo "$CON_PORT:${DEVICE_NAME}" >> $DEVICE_LIST
		DEVICE_NAME_OLD=${DEVICE_NAME}
	fi
done
)

echo '>>> .net >>>'
echo $DYNAGENCONF_PATH 
cat $DYNAGENCONF_PATH 
echo '<<< .net <<<'

echo "</device_list>" >> $XML_OUTPUT

cd $SIM_DIR

echo "executing $DYNAMIPS_PATH -H $PORT_START"
$DYNAMIPS_PATH -H $PORT_START & 
if [ ! "$?" -eq 0 ]; then
	exit -2;
fi;

#PEMU=1;
#echo $PEMU
echo "Je pemu?"
echo $PEMUS
if [ ! -z "${PEMUS}" ]
then
	if [ $PEMUS -gt 1 ];then
	#if [ ! -n "`ps -A|egrep \"pemu\"`" ];then
	echo "Spustam PEMU"
	  $PEMU_PATH $FW_PORT
	/opt/scripts/pemulimit.sh

	`cpulimit pemu`;
	fi;
	#fi;
fi


COUNT=1 
while [ -z "`netstat -tln | awk '{print $4}' | grep :$PORT_START$`" ]; do
#	echo "netstat -tln | awk '{print $4}' | grep :$PORT_START$"
	echo "Waiting $COUNT s";
	if [ $COUNT -gt 20 ];then
		echo "Dynamips not started cannot continue"
		killall dynamips
		killall vde_switch
		killall linux
		killall pemu
		killall python
		killall cpulimit
		echo "pokazilo sa to"
		exit 2;
	fi
	sleep 1;
	let COUNT=$COUNT+1;
done;

echo "$DYNAGEN_PATH $DYNAGENCONF_PATH" 

if [ $3 -a $3 == "FORE" ]; then
	$DYNAGEN_WRAPPER_PATH foreground $DYNAGEN_PATH  "$DYNAGENCONF_PATH" > $DYNAGEN_OUTPUTFILE
	DNG_EC=$?
	echo "DYNAGEN EXIT CODE $DNG_EC"
	
#	if [ ! "$DNG_EC" -eq 0 ]; then
		/usr/bin/mysql -u $MYSQL_USER --password=$MYSQL_PASS $MYSQL_DB -e "INSERT log SET type = 'error', id_user = '1', timestamp = '`date +%s`', message = '`cat $DYNAGEN_OUTPUTFILE`'";
#	fi;

else
	$DYNAGEN_WRAPPER_PATH $DYNAGEN_PATH "$DYNAGENCONF_PATH"

       # $DYNAGEN_PATH $DYNAGENCONF_PATH
fi;

DEVICE_LIST=`cat $XML_OUTPUT`

echo "Updatimg mysql"
if [ $CONF_STR -eq 0 ]; then
	/usr/bin/mysql -u $MYSQL_USER --password=$MYSQL_PASS $MYSQL_DB -e "UPDATE simulation SET is_active=1, started=`date +%s` , uid='`whoami`', devices='$DEVICE_LIST' WHERE id=$CONF_ID ;"
fi

chgrp $GROUP `ls -l $TMP_DIR | awk '{printf("%s %s\n",$3,"'$TMP_DIR'"$9)}' | grep $USER | awk '{print $2}'`
chmod g+w `ls -l $TMP_DIR | awk '{printf("%s %s\n",$3,"'$TMP_DIR'"$9)}' | grep $USER | awk '{print $2}'`

exit $DNG_EC;
